#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TorpedoRankType.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TorpedoRankType> Fish_TorpedoRankType::msSingleton(nullptr);

int Fish_TorpedoRankType::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TorpedoRankTypeData* Fish_TorpedoRankType::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TorpedoRankTypeData>& Fish_TorpedoRankType::GetMapData()
{
	return mMapData;
}

void Fish_TorpedoRankType::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TorpedoRankType::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TorpedoRankTypeData data;
		data.mID = element->IntAttribute("ID");
		data.mRankType = element->IntAttribute("RankType");
		{
			const char* NoticeValue = element->Attribute("NoticeValue");
			std::vector<std::string> vecNoticeValue;
			boost::split(vecNoticeValue, NoticeValue, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNoticeValue.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNoticeValue[i].c_str(), &temp))
				{
					data.mNoticeValue.push_back(temp);
				}
			}
		}
		{
			const char* Limit = element->Attribute("Limit");
			std::vector<std::string> vecLimit;
			boost::split(vecLimit, Limit, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecLimit.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecLimit[i].c_str(), &temp))
				{
					data.mLimit.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TorpedoRankType::Load()
{
	Load("../Config/Fish_TorpedoRankType.xml");
}

Fish_TorpedoRankType* Fish_TorpedoRankType::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TorpedoRankType());
	}
	return msSingleton.get();
}
